## cashbox 0.3

=== Makefile ===
#        file: Makefile
#   copyright: Bernd Schumacher <bernd@bschu.de> (2024)
#     license: GNU General Public License, version 3
# description: build cashbox package

LIBS   = $(shell ls *py | grep -v cashbox.py)
UIS    = $(shell ls *blp | sed -e "s/blp$$/ui/")
SHARE  = $(DESTDIR)/usr/share/cashbox
PYTHON = $(DESTDIR)/usr/share/cashbox/python3/cashbox
BIN    = $(DESTDIR)/usr/bin
APPL   = $(DESTDIR)/usr/share/applications
SVG    = $(DESTDIR)/usr/share/icons/hicolor/scalable/apps
MIME   = $(DESTDIR)/usr/share/mime/packages
MODIR  = $(DESTDIR)/usr/share/locale
MO     = de
UTF    = "de_DE.UTF-8 us_US.UTF-8"
MO1	   = $(shell for i in $(MO); do echo "$${i}/LC_MESSAGES/cashbox.mo"; done)
MO2	   = $(shell for i in $(MO1); do echo "po/locale/$${i}"; done)


all: $(UIS) $(MO2)

clean:

install: install-libs install-bin install-mo

install-libs: $(LIBS) $(UIS)
	@mkdir -p $(PYTHON); \
	for i in $^; do \
	    install -o root -g root -m 0644 $$i $(PYTHON)/; \
	done

install-bin: cashbox.py
	@mkdir -p $(BIN) $(APPL) $(SVG) $(MIME) $(SHARE)
	@install -o root -g root -m 0755 cashbox.py $(BIN)/cashbox
	@install -o root -g root -m 0644 de.bschu.cashbox.desktop $(APPL)
	@install -o root -g root -m 0644 de.bschu.cashbox.svg $(SVG)
	@install -o root -g root -m 0644 cashbox.xml $(MIME)
	@install -o root -g root -m 0644 cashbox.css $(SHARE)

install-mo: $(MO2)
	@for i in $(MO1); do \
	   mkdir -p $$(dirname $(MODIR)/$${i}); \
	   install -o root -g root -m 0644 po/locale/$${i} $(MODIR)/$${i}; \
	done

po/cashbox.pot: cashbox.py $(LIBS) $(UIS)
	@mkdir -p po
	@echo $^ | tr " " "\n" | xgettext --output=po/cashbox.pot -f -

po/de.po: po/cashbox.pot
	@l="$$(basename "$@" .po)"; \
	u="$$(echo " $(UTF) " | tr " " "\n" | grep "^$${l}")"; \
	[ -f $@ ] && msgmerge -o $@.new $@ $< || msginit -i $< -o $@ -l de_DE.UTF-8; \
	[ -f $@.new ] && mv $@.new $@

po/locale/%/LC_MESSAGES/cashbox.mo: po/%.po
	mkdir -p $$(dirname $@)
	msgfmt $< -o $@

p: $(UIS)
	mkdir -p po
	#xgettext --files-from=po/POTFILES --output=po/cashbox.pot
	mkdir -p po/locale/de/LC_MESSAGES
	msgfmt po/de.po -o po/locale/de/LC_MESSAGES/cashbox.mo

%.ui : %.blp
	blueprint-compiler compile $< >$@

=== debian/changelog ===
cashbox (0.3) unstable; urgency=medium

  * fixed copyright information for all files in debian/copyright
  * fixed typos

 -- Bernd Schumacher <bernd@bschu.de>  Sun, 05 May 2024 09:07:44 +0200

cashbox (0.2) unstable; urgency=medium

  * Initial release. closes: #1069879

 -- Bernd Schumacher <bernd@bschu.de>  Wed, 10 Apr 2024 11:37:55 +0200

## cashbox 0.3+nmu1

=== debian/changelog ===
cashbox (0.3+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload for testing migration. (Closes: #1081572)

 -- Boyuan Yang <byang@debian.org>  Thu, 12 Sep 2024 18:39:32 -0400

## cashbox 0.3.2

=== Makefile ===
--- 
+++ 
@@ -64,5 +64,6 @@
 	mkdir -p po/locale/de/LC_MESSAGES
 	msgfmt po/de.po -o po/locale/de/LC_MESSAGES/cashbox.mo
 
-%.ui : %.blp
-	blueprint-compiler compile $< >$@
+# temporarily disabled: (see changelog 0.3.1)
+# %.ui : %.blp
+#	blueprint-compiler compile $< >$@

=== debian/changelog ===
cashbox (0.3.2) unstable; urgency=medium

  * nothing new, only fix 0.3.1

 -- Bernd Schumacher <bernd@bschu.de>  Tue, 26 Nov 2024 10:00:54 +0100

cashbox (0.3.1) unstable; urgency=medium

  * build without blueprint-compiler, (as long as blueprint-compiler
    bug 1084500 will be fixed)
  * fix spelling errors

 -- Bernd Schumacher <bernd@bschu.de>  Tue, 26 Nov 2024 08:27:48 +0100

## cashbox 0.3.3

=== Makefile ===
#        file: Makefile
#   copyright: Bernd Schumacher <bernd@bschu.de> (2024)
#     license: GNU General Public License, version 3
# description: build cashbox package

ROOT    = $(shell [ "$(FLATPAK_DEST)" ] && echo $(shell whoami) || echo root)
USR     = $(shell [ "$(FLATPAK_DEST)" ] && echo $(FLATPAK_DEST) || echo /usr)
LIBS    = $(shell ls *py | grep -v cashbox.py)
UIS     = $(shell ls *blp | sed -e "s/blp$$/ui/")
SHARE   = $(DESTDIR)$(USR)/share/cashbox
PYTHON  = $(DESTDIR)$(USR)/share/cashbox/python3/cashbox
BIN     = $(DESTDIR)$(USR)/bin
APPL    = $(DESTDIR)$(USR)/share/applications
SVG     = $(DESTDIR)$(USR)/share/icons/hicolor/scalable/apps
MIME    = $(DESTDIR)$(USR)/share/mime/packages
MODIR   = $(DESTDIR)$(USR)/share/locale
MO      = de
UTF     = "de_DE.UTF-8 us_US.UTF-8"
MO1	= $(shell for i in $(MO); do echo "$${i}/LC_MESSAGES/cashbox.mo"; done)
MO2	= $(shell for i in $(MO1); do echo "po/locale/$${i}"; done)
META    = $(DESTDIR)$(USR)/share/metainfo
VERSION_BIN = ${shell sed -E -n -e "s/.*application_version.*= \"(\S+)\"$$/\1/p" read_appargs.py}
VERSION_DEB = ${shell head -1 debian/changelog | sed "s/.*(//" | sed "s/).*//"}
VERSION_FLATPAK = ${shell sed -E -n -e "s/^ *<release version=\"(\S+)\".*/\1/p" de.bschu.cashbox.metainfo.xml}

all: check_version $(UIS) $(MO2)

dbg:
	@echo "USR=<$(USR)> VERSION_BIN=<$(VERSION_BIN)> \
VERSION_DEB=<$(VERSION_DEB)> VERSION_FLATPAK=<$(VERSION_FLATPAK)>"

check_version:
ifneq ($(VERSION_BIN),$(VERSION_DEB))
	@echo "VERSION_BIN=<$(VERSION_BIN)> != VERSION_DEB=<$(VERSION_DEB)>"
	@exit 1
endif
ifneq ($(VERSION_FLATPAK),$(VERSION_DEB))
	@echo "VERSION_FLATPAK=<$(VERSION_FLATPAK)> != VERSION_DEB=<$(VERSION_DEB)>"
	@exit 1
endif

clean:

install: install-libs install-bin install-mo

install-libs: $(LIBS) $(UIS)
	@mkdir -p $(PYTHON); \
	for i in $^; do \
	    install -o $(ROOT) -g $(ROOT) -m 0644 $$i $(PYTHON)/; \
	done

install-bin: cashbox.py
	@mkdir -p $(BIN) $(APPL) $(SVG) $(MIME) $(SHARE) $(META)
	@install -o $(ROOT) -g $(ROOT) -m 0755 cashbox.py $(BIN)/cashbox
	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.desktop $(APPL)
	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.svg $(SVG)
	@install -o $(ROOT) -g $(ROOT) -m 0644 cashbox.xml $(MIME)
	@install -o $(ROOT) -g $(ROOT) -m 0644 cashbox.css $(SHARE)
	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.metainfo.xml $(META)

install-mo: $(MO2)
	@for i in $(MO1); do \
	   mkdir -p $$(dirname $(MODIR)/$${i}); \
	   install -o $(ROOT) -g $(ROOT) -m 0644 po/locale/$${i} $(MODIR)/$${i}; \
	done

po/cashbox.pot: cashbox.py $(LIBS) $(UIS)
	@mkdir -p po
	@echo $^ | tr " " "\n" | xgettext --output=po/cashbox.pot -f -

po/de.po: po/cashbox.pot
	@l="$$(basename "$@" .po)"; \
	u="$$(echo " $(UTF) " | tr " " "\n" | grep "^$${l}")"; \
	[ -f $@ ] && msgmerge -o $@.new $@ $< || msginit -i $< -o $@ -l de_DE.UTF-8; \
	[ -f $@.new ] && mv $@.new $@

po/locale/%/LC_MESSAGES/cashbox.mo: po/%.po
	mkdir -p $$(dirname $@)
	msgfmt $< -o $@

p: $(UIS)
	mkdir -p po
	#xgettext --files-from=po/POTFILES --output=po/cashbox.pot
	mkdir -p po/locale/de/LC_MESSAGES
	msgfmt po/de.po -o po/locale/de/LC_MESSAGES/cashbox.mo

# temporarily disabled: (see changelog 0.3.1)
# %.ui : %.blp
#	blueprint-compiler compile $< >$@

=== debian/changelog ===
cashbox (0.3.3) unstable; urgency=medium

  * prepare Makefile to build flatpak for librem5
  * fixes to run linter pylint without warnings
  * only use 2 dir sources (cashbox and cashbox/debian)

 -- Bernd Schumacher <bernd@bschu.de>  Tue, 25 Feb 2025 13:15:41 +0100

=== debian/control ===
Source: cashbox
Section: math
Priority: optional
Maintainer: Bernd Schumacher <bernd@bschu.de>
Rules-Requires-Root: binary-targets
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3
# temporarily disabled blueprint-compiler (see changelog 0.3.1)
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/cashbox
Vcs-Git: https://salsa.debian.org/debian/cashbox.git

Package: cashbox
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${python3:Depends},
 python3,
 python3-gi (>=3.47),
 libgtk-4-bin (>=4.12.5),
 gir1.2-adw-1 (>=1.4),
 libadwaita-1-0 (>1.4)
Description: cashbox - memorise cost and calculate price of articles
 cashbox memorises the cost of articles and calculates the total price and
 change. It is intended for small clubs on a celebration, where members are
 not experienced in memorizing prices and doing mental arithmetic.

## cashbox 0.3.4

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 # description: build cashbox package
 
 ROOT    = $(shell [ "$(FLATPAK_DEST)" ] && echo $(shell whoami) || echo root)
+ROOTG   = $(shell [ "$(FLATPAK_DEST)" ] && echo $(shell id -gn) || echo root)
 USR     = $(shell [ "$(FLATPAK_DEST)" ] && echo $(FLATPAK_DEST) || echo /usr)
 LIBS    = $(shell ls *py | grep -v cashbox.py)
 UIS     = $(shell ls *blp | sed -e "s/blp$$/ui/")
@@ -22,12 +23,15 @@
 VERSION_BIN = ${shell sed -E -n -e "s/.*application_version.*= \"(\S+)\"$$/\1/p" read_appargs.py}
 VERSION_DEB = ${shell head -1 debian/changelog | sed "s/.*(//" | sed "s/).*//"}
 VERSION_FLATPAK = ${shell sed -E -n -e "s/^ *<release version=\"(\S+)\".*/\1/p" de.bschu.cashbox.metainfo.xml}
+VERSION_REF = $(shell echo $(VERSION_DEB) | sed "s/\./_/g" | sed "s/^/debian_version_/")
+VERSION_BADREF = $(shell find . -type f | grep -v Makefile | xargs grep -E -e "salsa\S*/raw" | grep -v -e "ref=$(VERSION_REF)")
 
 all: check_version $(UIS) $(MO2)
 
 dbg:
 	@echo "USR=<$(USR)> VERSION_BIN=<$(VERSION_BIN)> \
-VERSION_DEB=<$(VERSION_DEB)> VERSION_FLATPAK=<$(VERSION_FLATPAK)>"
+VERSION_DEB=<$(VERSION_DEB)> VERSION_FLATPAK=<$(VERSION_FLATPAK)> \
+VERSION_REF=<$(VERSION_REF)> VERSION_BADREF=<$(VERSION_BADREF)>"
 
 check_version:
 ifneq ($(VERSION_BIN),$(VERSION_DEB))
@@ -38,30 +42,36 @@
 	@echo "VERSION_FLATPAK=<$(VERSION_FLATPAK)> != VERSION_DEB=<$(VERSION_DEB)>"
 	@exit 1
 endif
+ifneq ($(VERSION_BADREF),)
+	@echo "found references to salsa.../raw without ref=$(VERSION_REF)"
+	@echo "$(VERSION_BADREF)"
+	@exit 1
+endif
 
 clean:
+	@rm -rf builddir .flatpak-builder .mypy_cache
 
 install: install-libs install-bin install-mo
 
 install-libs: $(LIBS) $(UIS)
 	@mkdir -p $(PYTHON); \
 	for i in $^; do \
-	    install -o $(ROOT) -g $(ROOT) -m 0644 $$i $(PYTHON)/; \
+	    install -o $(ROOT) -g $(ROOTG) -m 0644 $$i $(PYTHON)/; \
 	done
 
 install-bin: cashbox.py
 	@mkdir -p $(BIN) $(APPL) $(SVG) $(MIME) $(SHARE) $(META)
-	@install -o $(ROOT) -g $(ROOT) -m 0755 cashbox.py $(BIN)/cashbox
-	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.desktop $(APPL)
-	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.svg $(SVG)
-	@install -o $(ROOT) -g $(ROOT) -m 0644 cashbox.xml $(MIME)
-	@install -o $(ROOT) -g $(ROOT) -m 0644 cashbox.css $(SHARE)
-	@install -o $(ROOT) -g $(ROOT) -m 0644 de.bschu.cashbox.metainfo.xml $(META)
+	@install -o $(ROOT) -g $(ROOTG) -m 0755 cashbox.py $(BIN)/cashbox
+	@install -o $(ROOT) -g $(ROOTG) -m 0644 de.bschu.cashbox.desktop $(APPL)
+	@install -o $(ROOT) -g $(ROOTG) -m 0644 de.bschu.cashbox.svg $(SVG)
+	@install -o $(ROOT) -g $(ROOTG) -m 0644 de.bschu.cashbox.xml $(MIME)
+	@install -o $(ROOT) -g $(ROOTG) -m 0644 cashbox.css $(SHARE)
+	@install -o $(ROOT) -g $(ROOTG) -m 0644 de.bschu.cashbox.metainfo.xml $(META)
 
 install-mo: $(MO2)
 	@for i in $(MO1); do \
 	   mkdir -p $$(dirname $(MODIR)/$${i}); \
-	   install -o $(ROOT) -g $(ROOT) -m 0644 po/locale/$${i} $(MODIR)/$${i}; \
+	   install -o $(ROOT) -g $(ROOTG) -m 0644 po/locale/$${i} $(MODIR)/$${i}; \
 	done
 
 po/cashbox.pot: cashbox.py $(LIBS) $(UIS)
@@ -84,6 +94,5 @@
 	mkdir -p po/locale/de/LC_MESSAGES
 	msgfmt po/de.po -o po/locale/de/LC_MESSAGES/cashbox.mo
 
-# temporarily disabled: (see changelog 0.3.1)
-# %.ui : %.blp
-#	blueprint-compiler compile $< >$@
+%.ui : %.blp
+	blueprint-compiler compile $< >$@

=== debian/changelog ===
cashbox (0.3.4) unstable; urgency=medium

  * prepare to build flatpak on flathub
    is working. flathub bot builds aarch64 and x86_64 versions.
    sucessfully tested both versions on my pc and on my librem5.
    but reviewers have to many restrictions in the moment:
    reviewers say: 
      Makefile must not use command install with option -u or -g
    reviewers say:
      environment var PREFIX has to be used instead of FLATPAK_DEST
    unbelieveable?:
      see https://github.com/flathub/flathub/pull/6600
  * use flatpak-api to reference raw files from salsa
  * reenable blueprint-compiler because bug 1084500 is fixed
  * fix new blueprint-compiler related warnings
  * use env var XDG_DATA_DIRS
  * removed some unneeded print statements

 -- Bernd Schumacher <bernd@bschu.de>  Thu, 05 Jun 2025 13:41:52 +0200

## cashbox 0.3.7

=== Makefile ===
#        file: Makefile
#   copyright: Bernd Schumacher <bernd@bschu.de> (2024-2025)
#     license: GNU General Public License, version 3
# description: build cashbox package

prefix  := $(if $(prefix),$(prefix),/usr)
LIBS    = $(shell ls *py | grep -v cashbox.py)
UIS     = $(shell ls *blp | sed -e "s/blp$$/ui/")
SHARE   = $(DESTDIR)$(prefix)/share/cashbox
PYTHON  = $(DESTDIR)$(prefix)/share/cashbox/python3/cashbox
BIN     = $(DESTDIR)$(prefix)/bin
APPL    = $(DESTDIR)$(prefix)/share/applications
SVG     = $(DESTDIR)$(prefix)/share/icons/hicolor/scalable/apps
MIME    = $(DESTDIR)$(prefix)/share/mime/packages
MODIR   = $(DESTDIR)$(prefix)/share/locale
MO      = de
UTF     = "de_DE.UTF-8 us_US.UTF-8"
MO1	= $(shell for i in $(MO); do echo "$${i}/LC_MESSAGES/cashbox.mo"; done)
MO2	= $(shell for i in $(MO1); do echo "po/locale/$${i}"; done)
META    = $(DESTDIR)$(prefix)/share/metainfo
VERSION_BIN = ${shell sed -E -n -e "s/.*application_version.*= \"(\S+)\"$$/\1/p" read_appargs.py}
VERSION_DEB = ${shell head -1 debian/changelog | sed "s/.*(//" | sed "s/).*//"}
VERSION_FLATPAK = ${shell sed -E -n -e "s/^ *<release version=\"(\S+)\".*/\1/p" de.bschu.cashbox.metainfo.xml}
VERSION_REF = $(shell echo $(VERSION_DEB) | sed "s/\./_/g" | sed "s/^/debian_version_/")
VERSION_BADREF = $(shell find . -type f | grep -v Makefile | xargs grep -E -e "salsa\S*/raw" | grep -v -e "ref=$(VERSION_REF)")

all: check_version $(UIS) $(MO2)

dbg:
	@echo "prefix=<$(prefix)> VERSION_BIN=<$(VERSION_BIN)> \
VERSION_DEB=<$(VERSION_DEB)> VERSION_FLATPAK=<$(VERSION_FLATPAK)> \
VERSION_REF=<$(VERSION_REF)> VERSION_BADREF=<$(VERSION_BADREF)>"

check_version:
ifneq ($(VERSION_BIN),$(VERSION_DEB))
	@echo "VERSION_BIN=<$(VERSION_BIN)> != VERSION_DEB=<$(VERSION_DEB)>"
	@exit 1
endif
ifneq ($(VERSION_FLATPAK),$(VERSION_DEB))
	@echo "VERSION_FLATPAK=<$(VERSION_FLATPAK)> != VERSION_DEB=<$(VERSION_DEB)>"
	@exit 1
endif
ifneq ($(VERSION_BADREF),)
	@echo "found references to salsa.../raw without ref=$(VERSION_REF)"
	@echo "$(VERSION_BADREF)"
	@exit 1
endif

clean:
	@rm -rf builddir .flatpak-builder .mypy_cache debian/cashbox

install: dbg install-libs install-bin install-mo

install-libs: $(LIBS) $(UIS)
	@mkdir -p $(PYTHON); \
	for i in $^; do \
	    install -m 0644 $$i $(PYTHON)/; \
	done

install-bin: cashbox.py
	@mkdir -p $(BIN) $(APPL) $(SVG) $(MIME) $(SHARE) $(META)
	@install -m 0755 cashbox.py $(BIN)/cashbox
	@install -m 0644 de.bschu.cashbox.desktop $(APPL)
	@install -m 0644 de.bschu.cashbox.svg $(SVG)
	@install -m 0644 de.bschu.cashbox.xml $(MIME)
	@install -m 0644 cashbox.css $(SHARE)
	@install -m 0644 de.bschu.cashbox.metainfo.xml $(META)

install-mo: $(MO2)
	@for i in $(MO1); do \
	   mkdir -p $$(dirname $(MODIR)/$${i}); \
	   install -m 0644 po/locale/$${i} $(MODIR)/$${i}; \
	done

po/cashbox.pot: cashbox.py $(LIBS) $(UIS)
	@mkdir -p po
	@echo $^ | tr " " "\n" | xgettext --output=po/cashbox.pot -f -

po/de.po: po/cashbox.pot
	@l="$$(basename "$@" .po)"; \
	u="$$(echo " $(UTF) " | tr " " "\n" | grep "^$${l}")"; \
	[ -f $@ ] && msgmerge -o $@.new $@ $< || msginit -i $< -o $@ -l de_DE.UTF-8; \
	[ -f $@.new ] && mv $@.new $@

po/locale/%/LC_MESSAGES/cashbox.mo: po/%.po
	mkdir -p $$(dirname $@)
	msgfmt $< -o $@

p: $(UIS)
	mkdir -p po
	#xgettext --files-from=po/POTFILES --output=po/cashbox.pot
	mkdir -p po/locale/de/LC_MESSAGES
	msgfmt po/de.po -o po/locale/de/LC_MESSAGES/cashbox.mo

%.ui : %.blp
	blueprint-compiler compile $< >$@

=== debian/changelog ===
cashbox (0.3.7) unstable; urgency=medium

  * fixed bug in receipt_widget.py: "money_out" needs recalculation, if
    "money_sum" changes after "money_in" changed

 -- Bernd Schumacher <bernd@bschu.de>  Sun, 05 Oct 2025 16:55:26 +0200

cashbox (0.3.6) UNRELEASED; urgency=medium

  * now it is proofed, that cashbox built on flathub.org works technically,
    although at this time it will not be done

 -- Bernd Schumacher <bernd@bschu.de>  Thu, 19 Jun 2025 16:38:22 +0200

cashbox (0.3.5) UNRELEASED; urgency=medium

  * next try to make flathub reviewers happy to
    hopefully build deb and flatpak from this source

 -- Bernd Schumacher <bernd@bschu.de>  Mon, 09 Jun 2025 08:30:07 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-python,
- python3
-# temporarily disabled blueprint-compiler (see changelog 0.3.1)
+ python3,
+ blueprint-compiler
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/cashbox
 Vcs-Git: https://salsa.debian.org/debian/cashbox.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with  python3
